% MTODO 1
% TEST 1
%
% La referencia utilizada ha sido:
%
% 	M. Matilla, M. Ruz
%	A NON-PARAMETRIC INDEPENDENCE TEST USING PERMUTATION ENTROPY
%	Journal of Econometrics 144 (2008), 139-155
%
% Realizamos el test a travs de los pasos que se exponen a continuacin:
%
% PASO 1: Introducimos la serie temporal con la que vamos a trabajar.
% PASO 2: Calculamos h (entropa de permutacin).
% PASO 3: Realizamos el contraste de hiptesis.

function t1=test_1(serie_temp,m,nivel_confianza)

% PASO 1
% INTRODUCIMOS LA SERIE CON LA QUE VAMOS A TRABAJAR

serie=serie_temp; % serie temporal
T=length(serie); % nmero de elementos de la serie

% PASO 2
% CALCULAMOS h (ENTROPA DE PERMUTACIN) %

trozo_serie1=serie(1:m);
[trozo_ordenado1,permutacion1]=sort(trozo_serie1);
M_permutaciones=permutacion1;
Npermutaciones_diferentes=1;
Fabs_permutacion(1)=1;

for cont1=2:T-m+1
    
    trozo_serie=serie(cont1:cont1+m-1);
    [trozo_ordenado,permutacion]=sort(trozo_serie);
        
    testigo=0;
    
    for cont2=1:Npermutaciones_diferentes
        
        if(isequal(M_permutaciones(cont2,:),permutacion)==1)
            
            Fabs_permutacion(cont2)=Fabs_permutacion(cont2)+1;
            testigo=1;
            break            
            
        end
        
    end
    
    if(testigo==0)
        
    Npermutaciones_diferentes=Npermutaciones_diferentes+1;    
    M_permutaciones(Npermutaciones_diferentes,:)=permutacion;
    Fabs_permutacion(Npermutaciones_diferentes)=1;
    
    end
    
end

Frel_permutacion=Fabs_permutacion/(T-m+1);

H=0; % entropa de permutacin

for cont3=1:Npermutaciones_diferentes
      
    incremento_entropia=-(Frel_permutacion(cont3)*log(Frel_permutacion(cont3)));
    H=H+incremento_entropia;
      
end

% PASO 3
% REALIZAMOS EL CONTRASTE DE HIPTESIS

G=2*(T-m+1)*(log(factorial(m))-H); % estadstico de contraste

grados_libertad=factorial(m)-1;
chi_cuadrado=chi2inv(nivel_confianza/100,grados_libertad);

if(G<chi_cuadrado)
    
    t1=1;
    
else
        
    t1=0;
        
end

% Agregamos al resultado de salida los valores de H y G

auxiliar=t1;
t1=[H G auxiliar];