(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     23591,        518]
NotebookOptionsPosition[     23346,        505]
NotebookOutlinePosition[     23689,        520]
CellTagsIndexPosition[     23646,        517]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"M\[CapitalEAcute]TODO", " ", "2"}], "*)"}], " ", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"TEST", " ", "2"}], "-", "1"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"La", " ", "referencia", " ", "utilizada", " ", "ha", " ", 
    RowBox[{"sido", ":"}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\t", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"J", ".", " ", "S", ".", " ", "C\[AAcute]novas"}], ",", " ", 
    RowBox[{"A", ".", " ", "Guillam\[OAcute]n"}]}], "*)"}], 
  "\[IndentingNewLine]", "\t", 
  RowBox[{"(*", 
   RowBox[{
   "PERMUTATIONS", " ", "AND", " ", "TIME", " ", "SERIES", " ", "ANALYSIS"}], 
   "*)"}], "\[IndentingNewLine]", "\t", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Chaos", " ", "19", " ", 
     RowBox[{"(", "2009", ")"}]}], ",", " ", 
    RowBox[{"197", "-", "235"}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Seguimos", " ", "los", " ", "siguientes", " ", "pasos", " ", "para", " ", 
    "hacer", " ", "el", " ", 
    RowBox[{"test", ":"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"PASO", " ", "1"}], ":", " ", 
    RowBox[{
    "Introducimos", " ", "la", " ", "serie", " ", "temporal", " ", "con", " ",
      "la", " ", "que", " ", "vamos", " ", "a", " ", 
     RowBox[{"trabajar", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"PASO", " ", "2"}], ":", " ", 
    RowBox[{"Calculamos", " ", "H", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"entrop\[IAcute]a", " ", "topol\[OAcute]gica"}], ")"}], 
      "."}]}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"PASO", " ", "3"}], ":", " ", 
    RowBox[{"Realizamos", " ", "el", " ", "contraste", " ", "de", " ", 
     RowBox[{"hip\[OAcute]tesis", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Aclaraci\[OAcute]n", ":", " ", 
     RowBox[{
     "lo", " ", "que", " ", "aqu\[IAcute]", " ", "denominamos", " ", 
      "entrop\[IAcute]a", " ", "topol\[OAcute]gica", " ", "no", " ", "es"}]}],
     ",", " ", 
    RowBox[{"en", " ", "sentido", " ", "estricto"}], ",", " ", 
    RowBox[{"el", " ", "valor", " ", "real", " ", "de", " ", "dicha", " ", 
     RowBox[{"entrop\[IAcute]a", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Lo", " ", "que", " ", "en", " ", "realidad", " ", "representa", " ", "H", 
    " ", "es", " ", "el", " ", "n\[UAcute]mero", " ", "de", " ", 
    "permutaciones", " ", "diferentes", " ", "que", " ", "aparecen", " ", 
    "en", " ", "la", " ", 
    RowBox[{"serie", "."}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Hemos", " ", "utilizado", " ", "el", " ", "nombre", " ", "de", " ", 
    "entrop\[IAcute]a", " ", "topol\[OAcute]gica", " ", "porque", " ", "este",
     " ", "concepto", " ", "est\[AAcute]", " ", "directamente", " ", 
    "relacionado", " ", "con", " ", "el", " ", "n\[UAcute]mero", " ", "de", 
    " ", "permutaciones", " ", "diferentes", " ", "en", " ", "la", " ", 
    RowBox[{"serie", "."}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ClearAll", "[", 
    RowBox[{
    "serie", ",", "m", ",", "nivelConfianza", ",", "nivelSignificacion", ",", 
     "T", ",", "k", ",", "trozo1Serie", ",", "permutacion1", ",", 
     "Mpermutaciones", ",", "NpermutacionesDiferentes", ",", 
     "FabsPermutacion", ",", "cont1", ",", "trozoSerie", ",", "permutacion", 
     ",", "testigo", ",", "cont2", ",", "H", ",", 
     "NMaxPermutacionesDiferentes", ",", "auxiliarSuma", ",", "cont3", ",", 
     "valorDistrTeorica", ",", "test21"}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"PASO", " ", "1"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "INTRODUCIMOS", " ", "LA", " ", "SERIE", " ", "TEMPORAL", " ", "CON", " ",
      "LA", " ", "QUE", " ", "VAMOS", " ", "A", " ", "TRABAJAR"}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"serie", "=", 
     RowBox[{"RandomReal", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", "120"}], "]"}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{"serie", " ", "temporal"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"m", "=", "4"}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{"dimensi\[OAcute]n", " ", "de", " ", "inmersi\[OAcute]n", " ", 
      RowBox[{"(", 
       RowBox[{"'", "embedding", " ", 
        RowBox[{"dimension", "'"}]}], ")"}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"nivelConfianza", "=", "95"}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{"nivel", " ", "de", " ", "confianza", " ", "del", " ", "test"}], 
     "*)"}], "\[IndentingNewLine]", 
    RowBox[{"nivelSignificacion", "=", 
     RowBox[{"1", "-", 
      RowBox[{"(", 
       RowBox[{"nivelConfianza", "/", "100"}], ")"}]}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
     "nivel", " ", "de", " ", "significaci\[OAcute]n", " ", "del", " ", 
      "test"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"T", "=", 
     RowBox[{"Length", "[", "serie", "]"}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
     "n\[UAcute]mero", " ", "de", " ", "elementos", " ", "de", " ", "la", " ",
       "serie", " ", "temporal"}], "*)"}], "\n", 
    RowBox[{"k", "=", 
     RowBox[{"IntegerPart", "[", 
      RowBox[{"T", "/", "m"}], "]"}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
     "n\[UAcute]mero", " ", "de", " ", "trozos", " ", "en", " ", "que", " ", 
      "se", " ", "divide", " ", "la", " ", "serie", " ", "temporal"}], "*)"}],
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{"PASO", " ", "2"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{"CALCULAMOS", " ", "H", " ", 
      RowBox[{"(", 
       RowBox[{"ENTROP\[CapitalIAcute]A", " ", "TOPOL\[CapitalOAcute]GICA"}], 
       ")"}]}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "La", " ", "serie", " ", "temporal", " ", "se", " ", "dividir\[AAcute]",
        " ", "en", " ", "varias", " ", "partes", " ", 
       RowBox[{"(", "trozos", ")"}]}], ",", " ", 
      RowBox[{"cumpliendo", ":"}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "1.", "Cada", " ", "trozo", " ", "abarcar\[AAcute]", " ", "un", " ", 
      "conjunto", " ", "de", " ", "elementos", " ", 
      RowBox[{"consecutivos", "."}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{"2.", "Los", " ", "trozos", " ", "no", " ", "se", " ", 
      RowBox[{"solapar\[AAcute]n", "."}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "3.", "Entre", " ", "dos", " ", "trozos", " ", "consecutivos", " ", "no",
       " ", "se", " ", "dejar\[AAcute]n", " ", "elementos", " ", 
      RowBox[{"libres", "."}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "4.", "El", " ", "primer", " ", "trozo", " ", "se", " ", 
      "construir\[AAcute]", " ", "a", " ", "partir", " ", "del", " ", 
      "primer", " ", "elemento", " ", "de", " ", "la", " ", 
      RowBox[{"ventana", "."}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "5.", "Todos", " ", "los", " ", "trozos", " ", "tendr\[AAcute]n", " ", 
       "el", " ", "mismo", " ", "n\[UAcute]mero", " ", "de", " ", 
       "elementos"}], ",", " ", 
      RowBox[{"y", " ", "\[EAcute]ste", " ", "ser\[AAcute]", " ", "m", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"'", "embedding", " ", 
          RowBox[{"dimension", "'"}]}], ")"}], "."}]}]}], "*)"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"trozo1Serie", "=", 
     RowBox[{"serie", "[", 
      RowBox[{"[", 
       RowBox[{"1", ";;", "m"}], "]"}], "]"}]}], ";"}], " ", "\n", 
   RowBox[{
    RowBox[{"permutacion1", "=", 
     RowBox[{"Ordering", "[", "trozo1Serie", "]"}]}], ";"}], " ", "\n", 
   RowBox[{
    RowBox[{"Mpermutaciones", "=", 
     RowBox[{"{", "permutacion1", "}"}]}], ";"}], " ", "\n", 
   RowBox[{
    RowBox[{"NpermutacionesDiferentes", "=", "1"}], ";"}], " ", "\n", 
   RowBox[{
    RowBox[{"FabsPermutacion", "=", 
     RowBox[{"{", "1", "}"}]}], ";"}], " ", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", " ", 
     RowBox[{
      RowBox[{"cont1", "=", 
       RowBox[{"m", "+", "1"}]}], ",", 
      RowBox[{"cont1", "\[LessSlantEqual]", 
       RowBox[{"T", "-", "m", "+", "1"}]}], ",", 
      RowBox[{"cont1", "=", 
       RowBox[{"cont1", "+", "m"}]}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"trozoSerie", "=", 
        RowBox[{"serie", "[", 
         RowBox[{"[", 
          RowBox[{"cont1", ";;", 
           RowBox[{"cont1", "+", "m", "-", "1"}]}], "]"}], "]"}]}], ";", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"permutacion", "=", 
        RowBox[{"Ordering", "[", "trozoSerie", "]"}]}], ";", " ", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"testigo", "=", "0"}], ";", " ", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", " ", 
        RowBox[{
         RowBox[{"cont2", "=", "1"}], ",", 
         RowBox[{"cont2", "\[LessSlantEqual]", "NpermutacionesDiferentes"}], 
         ",", 
         RowBox[{"cont2", "++"}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Mpermutaciones", "[", 
              RowBox[{"[", "cont2", "]"}], "]"}], "\[Equal]", "permutacion"}],
             ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"FabsPermutacion", "[", 
               RowBox[{"[", "cont2", "]"}], "]"}], "=", 
              RowBox[{
               RowBox[{"FabsPermutacion", "[", 
                RowBox[{"[", "cont2", "]"}], "]"}], "+", "1"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"testigo", "=", "1"}], ";", "\[IndentingNewLine]", 
             RowBox[{"Break", "[", "]"}], ";"}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"testigo", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Mpermutaciones", "=", 
           RowBox[{"Append", "[", 
            RowBox[{"Mpermutaciones", ",", "permutacion"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"NpermutacionesDiferentes", "=", 
           RowBox[{"NpermutacionesDiferentes", "+", "1"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"FabsPermutacion", "=", 
           RowBox[{"Append", "[", 
            RowBox[{"FabsPermutacion", ",", "1"}], "]"}]}], ";"}]}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";"}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"PASO", " ", "3"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "REALIZAMOS", " ", "EL", " ", "CONTRASTE", " ", "DE", " ", 
     "HIP\[CapitalOAcute]TESIS"}], "*)"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "Determinamos", " ", "el", " ", "estad\[IAcute]stico", " ", "de", " ", 
     RowBox[{"contraste", "."}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "En", " ", "este", " ", "caso", " ", "el", " ", "estad\[IAcute]stico", 
     " ", "de", " ", "contrate", " ", "coincide", " ", "con", " ", "la", " ", 
     "entrop\[IAcute]a", " ", "topol\[OAcute]gica", " ", 
     RowBox[{"H", "."}]}], "*)"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"H", "=", "NpermutacionesDiferentes"}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{"entrop\[IAcute]a", " ", "topol\[OAcute]gica", " ", "H", " ", 
      RowBox[{"(", 
       RowBox[{"estad\[IAcute]stico", " ", "de", " ", "contraste"}], ")"}]}], 
     "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "A", " ", "partir", " ", "de", " ", "la", " ", "distribuci\[OAcute]n", 
       " ", "te\[OAcute]rica", " ", "de", " ", "probabilidad"}], ",", " ", 
      RowBox[{
      "calculamos", " ", "el", " ", "valor", " ", "que", " ", "hay", " ", 
       "que", " ", "comparar", " ", "con", " ", "el", " ", 
       "estad\[IAcute]stico", " ", "de", " ", 
       RowBox[{"contraste", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"prob", "[", 
      RowBox[{"k_", ",", "m_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"N", "[", 
      RowBox[{
       RowBox[{"StirlingS2", "[", 
        RowBox[{"k", ",", "t"}], "]"}], "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"m", "!"}], ")"}], "!"}], "/", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"m", "!"}], "-", "t"}], ")"}], "!"}]}], ")"}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "/", 
          RowBox[{"m", "!"}]}], ")"}], "^", "k"}]}], "]"}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
     "funci\[OAcute]n", " ", "puntual", " ", "de", " ", "probabilidad", " ", 
      "te\[OAcute]rica"}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"NMaxPermutacionesDiferentes", "=", 
     RowBox[{"Min", "[", 
      RowBox[{
       RowBox[{"m", "!"}], ",", "k"}], "]"}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
     "n\[UAcute]mero", " ", "m\[AAcute]ximo", " ", "de", " ", "permutaciones",
       " ", "diferentes", " ", "que", " ", "pueden", " ", "aparecer", " ", 
      "en", " ", "la", " ", "serie"}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"auxiliarSuma", "=", "0"}], ";"}], " ", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
     "Determinamos", " ", "a", " ", "partir", " ", "de", " ", "qu\[EAcute]", 
      " ", "valor", " ", "del", " ", "n\[UAcute]mero", " ", "de", " ", 
      "permutaciones", " ", "diferentes"}], ",", " ", 
     RowBox[{
     "la", " ", "probabilidad", " ", "asociada", " ", "es", " ", "mayor", " ",
       "o", " ", "igual", " ", "a", " ", 
      RowBox[{"nivelConfianza", "/", "100."}]}]}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", " ", "[", 
     RowBox[{
      RowBox[{"cont3", "=", "NMaxPermutacionesDiferentes"}], ",", 
      RowBox[{"cont3", "\[GreaterSlantEqual]", "1"}], ",", 
      RowBox[{"cont3", "--"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"auxiliarSuma", "=", 
        RowBox[{"auxiliarSuma", "+", 
         RowBox[{"prob", "[", 
          RowBox[{"k", ",", "m", ",", "cont3"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"auxiliarSuma", "\[GreaterSlantEqual]", 
          RowBox[{"nivelConfianza", "/", "100"}]}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Break", "[", "]"}], ";"}]}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"valorDistrTeorica", "=", "cont3"}], ";"}], "\[IndentingNewLine]",
    "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
     "Si", " ", "la", " ", "variable", " ", "test21", " ", "toma", " ", "el", 
      " ", "valor", " ", "1"}], ",", " ", 
     RowBox[{
     "no", " ", "rechazamos", " ", "la", " ", "hip\[OAcute]tesis", " ", 
      RowBox[{"nula", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"Si", " ", "en", " ", "cambio"}], ",", " ", 
     RowBox[{
     "la", " ", "variable", " ", "test21", " ", "toma", " ", "el", " ", 
      "valor", " ", "0"}], ",", " ", 
     RowBox[{
     "s\[IAcute]", " ", "rechazamos", " ", "la", " ", "hip\[OAcute]tesis", 
      " ", 
      RowBox[{"nula", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"H", "\[GreaterSlantEqual]", "valorDistrTeorica"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"test21", "=", "1"}], ",", " ", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"test21", "=", "0"}], ";"}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   "\"\<Representaci\[OAcute]n gr\[AAcute]fica de los elementos de la serie \
temporal\>\"", "\[IndentingNewLine]", 
   RowBox[{"ListPlot", "[", "serie", "]"}], "\[IndentingNewLine]", 
   "\"\<Entalp\[IAcute]a topol\[OAcute]gica 'H' (estad\[IAcute]stico de \
contraste)\>\"", "\[IndentingNewLine]", "H", "\[IndentingNewLine]", 
   "\"\<Valor obtenido de la distribuci\[OAcute]n te\[OAcute]rica\>\"", 
   "\[IndentingNewLine]", "valorDistrTeorica", "\[IndentingNewLine]", 
   "\"\<Valor real del nivel de confianza\>\"", "\[IndentingNewLine]", 
   RowBox[{"100", "*", "auxiliarSuma"}], "\[IndentingNewLine]", 
   "\"\<Resultado del test\>\"", "\[IndentingNewLine]", "test21"}]}]], "Input",
 CellChangeTimes->{{3.530106434618278*^9, 3.530106436849082*^9}, {
   3.530106496144786*^9, 3.530106637169034*^9}, {3.5301066899127264`*^9, 
   3.5301067759624777`*^9}, {3.5301073191398315`*^9, 3.5301073538966928`*^9}, 
   3.530107388497554*^9, {3.5301074731277018`*^9, 3.530107487557728*^9}, {
   3.530107524264592*^9, 3.5301075270101967`*^9}, {3.530107580752291*^9, 
   3.5301075876163034`*^9}, {3.530107679094864*^9, 3.5301077152557273`*^9}, {
   3.5301084702963486`*^9, 3.5301084920565586`*^9}, {3.5301087220103397`*^9, 
   3.5301088142084684`*^9}, 3.5301088678244534`*^9, {3.5301088986241693`*^9, 
   3.530108972838499*^9}, {3.5301090174389825`*^9, 3.530109144349044*^9}, {
   3.5301091993581066`*^9, 3.5301092279286942`*^9}, {3.530109258417395*^9, 
   3.530109260224495*^9}, {3.5301112907616944`*^9, 3.5301113107372217`*^9}, {
   3.5301113573393564`*^9, 3.5301113802249823`*^9}, {3.5301114163059435`*^9, 
   3.530111440606681*^9}, {3.530111965210145*^9, 3.5301119735272913`*^9}, 
   3.5301120064639535`*^9, {3.53011211254035*^9, 3.530112116123466*^9}, {
   3.530112171985607*^9, 3.5301122081873455`*^9}, {3.5301122689597697`*^9, 
   3.530112290443204*^9}, {3.530112322932852*^9, 3.53011232742397*^9}, {
   3.5301123830975323`*^9, 3.5301124074391904`*^9}, {3.530142353404604*^9, 
   3.5301423730762386`*^9}, 3.530142656887537*^9, {3.530142826366235*^9, 
   3.530142829673441*^9}, 3.5301429635684757`*^9, {3.530143292339053*^9, 
   3.5301433072994795`*^9}, {3.530143356033965*^9, 3.5301433562055655`*^9}, 
   3.530144447614682*^9, {3.530144592772938*^9, 3.5301446211805873`*^9}, {
   3.5301447042975335`*^9, 3.530144705982336*^9}, {3.530145351090269*^9, 
   3.530145381089122*^9}, {3.5301456896888638`*^9, 3.5301456899384646`*^9}, {
   3.5301457758322153`*^9, 3.5301458504627466`*^9}, {3.5301459031128387`*^9, 
   3.5301459789445724`*^9}, {3.5302141932981606`*^9, 
   3.5302141949361634`*^9}, {3.5302143053063574`*^9, 3.530214305633958*^9}, {
   3.532352475347751*^9, 3.5323525103058367`*^9}, {3.532352558918858*^9, 
   3.5323525703154707`*^9}, {3.5323526417075167`*^9, 
   3.5323526468807955`*^9}, {3.5323526874913898`*^9, 
   3.5323526938883333`*^9}, {3.532352725242626*^9, 3.532352730033883*^9}, {
   3.53235641423726*^9, 3.532356451926238*^9}, {3.5323597795085793`*^9, 
   3.5323599638824773`*^9}, {3.5323599941307974`*^9, 
   3.5323601396701217`*^9}, {3.5323623274117813`*^9, 
   3.5323623447922964`*^9}, {3.532362432189281*^9, 3.532362448083517*^9}, {
   3.5323624903021364`*^9, 3.5323624998764467`*^9}, {3.532362536365559*^9, 
   3.532362551741766*^9}, {3.5323625837212453`*^9, 3.532362687654904*^9}, 
   3.532362734780176*^9, {3.5323627688605647`*^9, 3.532362832334694*^9}, {
   3.5323628796863804`*^9, 3.5323629939427757`*^9}, {3.5323630349501295`*^9, 
   3.5323630662425737`*^9}, {3.5323634912574534`*^9, 3.532363505521002*^9}, {
   3.532363553657728*^9, 3.5323635768205442`*^9}, {3.5323636706356716`*^9, 
   3.532363728326112*^9}, {3.532363778757966*^9, 3.5323638501139965`*^9}, {
   3.5323639032499876`*^9, 3.532363918497187*^9}, {3.5323639746751366`*^9, 
   3.532364075097413*^9}, 3.532364109001792*^9, {3.532364314650323*^9, 
   3.532364334366558*^9}, {3.532364414165762*^9, 3.532364450658849*^9}, {
   3.5323644929772696`*^9, 3.5323644976405363`*^9}, {3.532364559330065*^9, 
   3.5323645871616564`*^9}, {3.5323646196595154`*^9, 
   3.5323646952085457`*^9}, {3.532364904784173*^9, 3.532364911342548*^9}, {
   3.532364973585651*^9, 3.5323649843272133`*^9}, {3.5323650315113096`*^9, 
   3.5323650331415925`*^9}, {3.532365065033666*^9, 3.5323651367964334`*^9}, {
   3.5323651889881725`*^9, 3.532365189492201*^9}, {3.53263746699842*^9, 
   3.5326374741588326`*^9}, {3.5326443332047873`*^9, 
   3.5326444068837166`*^9}, {3.5326445648651943`*^9, 
   3.5326445686248007`*^9}, {3.532644641617329*^9, 3.53264470461024*^9}, {
   3.532644890000965*^9, 3.53264489826898*^9}, {3.53264493254224*^9, 
   3.532644976893118*^9}, {3.5326450613048663`*^9, 3.5326451424094086`*^9}, {
   3.5326451843422823`*^9, 3.5326451980079064`*^9}, {3.5326452345743704`*^9, 
   3.5326452617028184`*^9}, {3.532645334398946*^9, 3.532645334539346*^9}, {
   3.53264636159835*^9, 3.532646458848921*^9}, 3.5326465428082685`*^9, {
   3.5326467421142187`*^9, 3.5326467521450357`*^9}, {3.532646877444456*^9, 
   3.532646878614458*^9}, {3.532647547075632*^9, 3.532647560600856*^9}, {
   3.5326482736538086`*^9, 3.532648393836419*^9}, {3.53558697307599*^9, 
   3.535587027676086*^9}, {3.535587083477384*^9, 3.535587099748213*^9}, {
   3.535587168871934*^9, 3.5355871762195473`*^9}, {3.535587356306263*^9, 
   3.5355873814535074`*^9}, {3.5355874556004376`*^9, 
   3.5355875428357906`*^9}, {3.535587573552245*^9, 3.535587747804551*^9}, 
   3.5355902876878147`*^9, {3.5363910712368913`*^9, 3.536391071767292*^9}, {
   3.536409962448786*^9, 3.5364099716338415`*^9}, {3.5364101618203297`*^9, 
   3.5364101749675283`*^9}, {3.5364257728838463`*^9, 3.536425774381449*^9}, {
   3.536438800979662*^9, 3.5364388024427404`*^9}}]
},
WindowSize->{1264, 825},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 22785, 483, 2595, "Input"]
}
]
*)

(* End of internal cache information *)
