(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     38068,        802]
NotebookOptionsPosition[     37823,        789]
NotebookOutlinePosition[     38166,        804]
CellTagsIndexPosition[     38123,        801]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"M\[CapitalEAcute]TODO", " ", "2"}], "*)"}], " ", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"TEST", " ", "2"}], "-", "2"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"La", " ", "referencia", " ", "utilizada", " ", "ha", " ", 
    RowBox[{"sido", ":"}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\t", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"J", ".", " ", "S", ".", " ", "C\[AAcute]novas"}], ",", " ", 
    RowBox[{"A", ".", " ", "Guillam\[OAcute]n"}]}], "*)"}], 
  "\[IndentingNewLine]", "\t", 
  RowBox[{"(*", 
   RowBox[{
   "PERMUTATIONS", " ", "AND", " ", "TIME", " ", "SERIES", " ", "ANALYSIS"}], 
   "*)"}], "\[IndentingNewLine]", "\t", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Chaos", " ", "19", " ", 
     RowBox[{"(", "2009", ")"}]}], ",", " ", 
    RowBox[{"197", "-", "235"}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Hacemos", " ", "el", " ", "test", " ", "siguiendo", " ", "los", " ", 
    "pasos", " ", "que", " ", "se", " ", "muestran", " ", "a", " ", 
    RowBox[{"continuaci\[OAcute]n", ":"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"PASO", " ", "1"}], ":", " ", 
    RowBox[{
    "Introducimos", " ", "la", " ", "serie", " ", "temporal", " ", "con", " ",
      "la", " ", "que", " ", "vamos", " ", "a", " ", 
     RowBox[{"trabajar", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"PASO", " ", "2"}], ":", " ", 
    RowBox[{
    "Seleccionamos", " ", "el", " ", "n\[UAcute]mero", " ", "de", " ", 
     "ventanas", " ", "y", " ", "su", " ", 
     RowBox[{"tama\[NTilde]o", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"PASO", " ", "3"}], ":", " ", 
    RowBox[{"Calculamos", " ", "H", " ", 
     RowBox[{"(", 
      RowBox[{"entrop\[IAcute]a", " ", "topol\[OAcute]gica"}], ")"}], " ", 
     "en", " ", "cada", " ", "una", " ", "de", " ", "las", " ", 
     RowBox[{"ventanas", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"PASO", " ", "4"}], ":", " ", 
    RowBox[{"Realizamos", " ", "el", " ", "contraste", " ", "de", " ", 
     RowBox[{"hip\[OAcute]tesis", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Aclaraci\[OAcute]n", ":", " ", 
     RowBox[{
     "lo", " ", "que", " ", "aqu\[IAcute]", " ", "denominamos", " ", 
      "entrop\[IAcute]a", " ", "topol\[OAcute]gica", " ", "no", " ", "es"}]}],
     ",", " ", 
    RowBox[{"en", " ", "sentido", " ", "estricto"}], ",", " ", 
    RowBox[{"el", " ", "valor", " ", "real", " ", "de", " ", "dicha", " ", 
     RowBox[{"entrop\[IAcute]a", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Lo", " ", "que", " ", "en", " ", "realidad", " ", "representa", " ", "H", 
    " ", "es", " ", "el", " ", "n\[UAcute]mero", " ", "de", " ", 
    "permutaciones", " ", "diferentes", " ", "que", " ", "aparecen", " ", 
    "en", " ", "la", " ", 
    RowBox[{"serie", "."}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Hemos", " ", "utilizado", " ", "el", " ", "nombre", " ", "de", " ", 
    "entrop\[IAcute]a", " ", "topol\[OAcute]gica", " ", "porque", " ", "este",
     " ", "concepto", " ", "est\[AAcute]", " ", "directamente", " ", 
    "relacionado", " ", "con", " ", "el", " ", "n\[UAcute]mero", " ", "de", 
    " ", "permutaciones", " ", "diferentes", " ", "en", " ", "la", " ", 
    RowBox[{"serie", "."}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ClearAll", "[", 
    RowBox[{
    "serie", ",", "m", ",", "nivelConfianza", ",", "nivelSignificacion", ",", 
     "T", ",", "Tventana", ",", "Nventanas", ",", "NelementosPerdidos", ",", 
     "ventana1", ",", "Mventanas", ",", "cont1", ",", "ventanaCont1", ",", 
     "k", ",", "vectorNpermutacionesDiferentes", ",", "func1", ",", "cont2", 
     ",", "ventana", ",", "trozo1Ventana", ",", "permutacion1Ventana", ",", 
     "MpermutacionesVentana", ",", "NpermutacionesDiferentesVentana", ",", 
     "FabsPermutacionVentana", ",", "cont3", ",", "trozoVentana", ",", 
     "permutacionVentana", ",", "testigo", ",", "cont4", ",", "vectorH", ",", 
     "NMaxPermutacionesDiferentes", ",", "sumaEstContraste", ",", "cont5", 
     ",", "fi", ",", "ei", ",", "cont6", ",", "EstContraste", ",", 
     "gradosLibertad", ",", "chiCuadrado", ",", "test22"}], "]"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"PASO", " ", "1"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "INTRODUCIMOS", " ", "LA", " ", "SERIE", " ", "TEMPORAL", " ", "CON", " ",
      "LA", " ", "QUE", " ", "VAMOS", " ", "A", " ", "TRABAJAR"}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"serie", "=", 
     RowBox[{"RandomReal", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", "4800"}], "]"}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"serie", " ", "temporal"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"m", "=", "4"}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{"dimensi\[OAcute]n", " ", "de", " ", "inmersi\[OAcute]n", " ", 
      RowBox[{"(", 
       RowBox[{"'", "embedding", " ", 
        RowBox[{"dimension", "'"}]}], ")"}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"nivelConfianza", "=", "99"}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{"nivel", " ", "de", " ", "confianza", " ", "del", " ", "test"}], 
     "*)"}], "\[IndentingNewLine]", 
    RowBox[{"nivelSignificacion", "=", 
     RowBox[{"1", "-", 
      RowBox[{"(", 
       RowBox[{"nivelConfianza", "/", "100"}], ")"}]}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
     "nivel", " ", "de", " ", "significaci\[OAcute]n", " ", "del", " ", 
      "test"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"T", "=", 
     RowBox[{"Length", "[", "serie", "]"}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
     "n\[UAcute]mero", " ", "de", " ", "elementos", " ", "de", " ", "la", " ",
       "serie", " ", "temporal"}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{"PASO", " ", "2"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "SELECCIONAMOS", " ", "EL", " ", "N\[CapitalUAcute]MERO", " ", "DE", " ",
       "VENTANAS", " ", "Y", " ", "SU", " ", "TAMA\[CapitalNTilde]O"}], 
     "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "Vamos", " ", "a", " ", "dividir", " ", "la", " ", "serie", " ", 
       "temporal", " ", "en", " ", "varias", " ", "partes", " ", 
       RowBox[{"(", "ventanas", ")"}]}], ",", " ", 
      RowBox[{"cumpliendo", ":"}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "1.", "Cada", " ", "ventana", " ", "abarcar\[AAcute]", " ", "un", " ", 
      "conjunto", " ", "de", " ", "elementos", " ", 
      RowBox[{"consecutivos", "."}]}], "*)"}], " ", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{"2.", "Las", " ", "ventanas", " ", "no", " ", "se", " ", 
      RowBox[{"solapar\[AAcute]n", "."}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "3.", "Entre", " ", "dos", " ", "ventanas", " ", "consecutivas", " ", 
      "no", " ", "se", " ", "dejar\[AAcute]n", " ", "elementos", " ", 
      RowBox[{"libres", "."}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "4.", "La", " ", "primera", " ", "ventana", " ", "se", " ", 
      "construir\[AAcute]", " ", "a", " ", "partir", " ", "del", " ", 
      "primer", " ", "elemento", " ", "de", " ", "la", " ", 
      RowBox[{"serie", "."}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "5.", "Todas", " ", "las", " ", "ventanas", " ", "tendr\[AAcute]n", " ",
        "el", " ", "mismo", " ", "n\[UAcute]mero", " ", "de", " ", 
       "elementos"}], ",", " ", 
      RowBox[{"y", " ", "\[EAcute]ste", " ", "ser\[AAcute]", " ", "5", 
       RowBox[{
        RowBox[{"m", "!"}], "."}]}]}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "La", " ", "condici\[OAcute]n", " ", "4", " ", "implica", " ", "que"}], 
      ",", " ", 
      RowBox[{
      "en", " ", "caso", " ", "de", " ", "tener", " ", "elementos", " ", 
       "sobrantes"}], ",", " ", 
      RowBox[{
      "estos", " ", "ser\[AAcute]n", " ", "los", " ", "del", " ", "final", 
       " ", "de", " ", "la", " ", 
       RowBox[{"serie", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "En", " ", "el", " ", "caso", " ", "de", " ", "que", " ", 
       "s\[OAcute]lo", " ", "se", " ", "considere", " ", "una", " ", 
       "ventana"}], ",", " ", 
      RowBox[{
      "\[EAcute]sta", " ", "abarcar\[AAcute]", " ", "toda", " ", "la", " ", 
       "serie", " ", 
       RowBox[{"temporal", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "Esta", " ", "imposici\[OAcute]n", " ", "evitar\[AAcute]", " ", "la", 
      " ", "p\[EAcute]rdida", " ", "de", " ", "elementos", " ", "de", " ", 
      "la", " ", "serie", " ", "en", " ", "el", " ", "caso", " ", "de", " ", 
      "que", " ", "el", " ", "n\[UAcute]mero", " ", "total", " ", "de", " ", 
      "elementos", " ", "est\[EAcute]", " ", "entre", " ", "5", 
      RowBox[{"m", "!"}], " ", "y", " ", "2", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"5", 
         RowBox[{"m", "!"}]}], ")"}], "."}]}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"T", "\[GreaterSlantEqual]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"5", "*", 
          RowBox[{"m", "!"}]}], ")"}], "*", "2"}]}], ",", " ", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Tventana", "=", 
        RowBox[{"5", "*", 
         RowBox[{"m", "!"}]}]}], ";", " ", "\[IndentingNewLine]", 
       RowBox[{"Nventanas", "=", 
        RowBox[{"IntegerPart", "[", 
         RowBox[{"T", "/", "Tventana"}], "]"}]}]}], ",", " ", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Tventana", "=", "T"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Nventanas", "=", "1"}], ";"}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"NelementosPerdidos", "=", 
     RowBox[{"T", "-", 
      RowBox[{"Nventanas", "*", "Tventana"}]}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
     "n\[UAcute]mero", " ", "de", " ", "elementos", " ", "perdidos", " ", 
      RowBox[{"(", 
       RowBox[{"al", " ", "final", " ", "de", " ", "la", " ", "serie"}], 
       ")"}]}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"ventana1", "=", 
     RowBox[{"serie", "[", 
      RowBox[{"[", 
       RowBox[{"1", ";;", "Tventana"}], "]"}], "]"}]}], ";"}], " ", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Mventanas", "=", 
     RowBox[{"{", "ventana1", "}"}]}], ";"}], " ", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"cont1", "=", "2"}], ",", 
      RowBox[{"cont1", "\[LessSlantEqual]", "Nventanas"}], ",", 
      RowBox[{"cont1", "++"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ventanaCont1", "=", 
        RowBox[{"serie", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"cont1", "-", "1"}], ")"}], "*", "Tventana"}], "+", 
            "1"}], ";;", 
           RowBox[{"cont1", "*", "Tventana"}]}], "]"}], "]"}]}], ";", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"Mventanas", "=", 
        RowBox[{"Append", "[", 
         RowBox[{"Mventanas", ",", "ventanaCont1"}], "]"}]}], ";"}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"PASO", " ", "3"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"CALCULAMOS", " ", "H", " ", 
     RowBox[{"(", 
      RowBox[{"ENTROP\[CapitalIAcute]A", " ", "TOPOL\[CapitalOAcute]GICA"}], 
      ")"}], " ", "EN", " ", "CADA", " ", "UNA", " ", "DE", " ", "LAS", " ", 
     "VENTANAS"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
     "Cada", " ", "ventana", " ", "se", " ", "dividir\[AAcute]", " ", "en", 
      " ", "varias", " ", "partes", " ", 
      RowBox[{"(", "trozos", ")"}]}], ",", " ", 
     RowBox[{"cumpliendo", ":"}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "1.", "Cada", " ", "trozo", " ", "abarcar\[AAcute]", " ", "un", " ", 
     "conjunto", " ", "de", " ", "elementos", " ", 
     RowBox[{"consecutivos", "."}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"2.", "Los", " ", "trozos", " ", "no", " ", "se", " ", 
     RowBox[{"solapar\[AAcute]n", "."}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "3.", "Entre", " ", "dos", " ", "trozos", " ", "consecutivos", " ", "no", 
     " ", "se", " ", "dejar\[AAcute]n", " ", "elementos", " ", 
     RowBox[{"libres", "."}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "4.", "El", " ", "primer", " ", "trozo", " ", "se", " ", 
     "construir\[AAcute]", " ", "a", " ", "partir", " ", "del", " ", "primer",
      " ", "elemento", " ", "de", " ", "la", " ", 
     RowBox[{"ventana", "."}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
     "5.", "Todos", " ", "los", " ", "trozos", " ", "tendr\[AAcute]n", " ", 
      "el", " ", "mismo", " ", "n\[UAcute]mero", " ", "de", " ", 
      "elementos"}], ",", " ", 
     RowBox[{"y", " ", "\[EAcute]ste", " ", "ser\[AAcute]", " ", "m", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"'", "embedding", " ", 
         RowBox[{"dimension", "'"}]}], ")"}], "."}]}]}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "No", " ", "se", " ", "perder\[AAcute]n", " ", "elementos", " ", "en", 
     " ", "las", " ", 
     RowBox[{"ventanas", "."}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "Esto", " ", "se", " ", "debe", " ", "a", " ", "que", " ", "la", " ", 
     "divisi\[OAcute]n", " ", "del", " ", "n\[UAcute]mero", " ", "de", " ", 
     "elementos", " ", "de", " ", "cada", " ", "ventana", " ", 
     RowBox[{"(", 
      RowBox[{"5", 
       RowBox[{"m", "!"}]}], ")"}], " ", "entre", " ", "el", " ", 
     "tama\[NTilde]o", " ", "de", " ", "cada", " ", "trozo", " ", 
     RowBox[{"(", "m", ")"}], " ", "es", " ", "una", " ", "divisi\[OAcute]n", 
     " ", 
     RowBox[{"exacta", "."}]}], "*)"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"k", "=", 
     RowBox[{"Tventana", "/", "m"}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
     "n\[UAcute]mero", " ", "de", " ", "trozos", " ", "en", " ", "que", " ", 
      "se", " ", "divide", " ", "cada", " ", "ventana"}], "*)"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "Contamos", " ", "el", " ", "n\[UAcute]mero", " ", "de", " ", 
      "permutaciones", " ", "diferentes", " ", "en", " ", "cada", " ", 
      RowBox[{"ventana", "."}]}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"vectorNpermutacionesDiferentes", "=", 
     RowBox[{"Array", "[", 
      RowBox[{"func1", ",", "Nventanas"}], "]"}]}], ";"}], " ", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"cont2", "=", "1"}], ",", 
      RowBox[{"cont2", "\[LessSlantEqual]", "Nventanas"}], ",", 
      RowBox[{"cont2", "++"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ventana", "=", 
        RowBox[{"Mventanas", "[", 
         RowBox[{"[", "cont2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"trozo1Ventana", "=", 
        RowBox[{"ventana", "[", 
         RowBox[{"[", 
          RowBox[{"1", ";;", "m"}], "]"}], "]"}]}], ";", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"permutacion1Ventana", "=", 
        RowBox[{"Ordering", "[", "trozo1Ventana", "]"}]}], ";", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"MpermutacionesVentana", "=", 
        RowBox[{"{", "permutacion1Ventana", "}"}]}], ";", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"NpermutacionesDiferentesVentana", "=", "1"}], ";", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"FabsPermutacionVentana", "=", 
        RowBox[{"{", "1", "}"}]}], ";", " ", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", " ", 
        RowBox[{
         RowBox[{"cont3", "=", 
          RowBox[{"m", "+", "1"}]}], ",", 
         RowBox[{"cont3", "\[LessSlantEqual]", 
          RowBox[{"Tventana", "-", "m", "+", "1"}]}], ",", 
         RowBox[{"cont3", "=", 
          RowBox[{"cont3", "+", "m"}]}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"trozoVentana", "=", 
           RowBox[{"ventana", "[", 
            RowBox[{"[", 
             RowBox[{"cont3", ";;", 
              RowBox[{"cont3", "+", "m", "-", "1"}]}], "]"}], "]"}]}], ";", 
          " ", "\[IndentingNewLine]", 
          RowBox[{"permutacionVentana", "=", 
           RowBox[{"Ordering", "[", "trozoVentana", "]"}]}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"testigo", "=", "0"}], ";", " ", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"For", "[", " ", 
           RowBox[{
            RowBox[{"cont4", "=", "1"}], ",", 
            RowBox[{
            "cont4", "\[LessSlantEqual]", "NpermutacionesDiferentesVentana"}],
             ",", 
            RowBox[{"cont4", "++"}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"MpermutacionesVentana", "[", 
                 RowBox[{"[", "cont4", "]"}], "]"}], "\[Equal]", 
                "permutacionVentana"}], ",", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"FabsPermutacionVentana", "[", 
                  RowBox[{"[", "cont4", "]"}], "]"}], "=", 
                 RowBox[{
                  RowBox[{"FabsPermutacionVentana", "[", 
                   RowBox[{"[", "cont4", "]"}], "]"}], "+", "1"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"testigo", "=", "1"}], ";", "\[IndentingNewLine]", 
                RowBox[{"Break", "[", "]"}], ";"}]}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"testigo", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"NpermutacionesDiferentesVentana", "=", 
              RowBox[{"NpermutacionesDiferentesVentana", "+", "1"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"MpermutacionesVentana", "=", 
              RowBox[{"Append", "[", 
               RowBox[{"MpermutacionesVentana", ",", "permutacionVentana"}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"FabsPermutacionVentana", "=", 
              RowBox[{"Append", "[", 
               RowBox[{"FabsPermutacionVentana", ",", "1"}], "]"}]}], ";"}]}],
            "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";"}]}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"func1", "[", "cont2", "]"}], "=", 
        "NpermutacionesDiferentesVentana"}], ";"}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "Construimos", " ", "el", " ", "vector", " ", "de", " ", 
     "entrop\[IAcute]as", " ", "topol\[OAcute]gicas", " ", 
     RowBox[{
      RowBox[{"(", "vectorH", ")"}], "."}]}], "*)"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vectorH", "=", "vectorNpermutacionesDiferentes"}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
     "vector", " ", "cuyos", " ", "elementos", " ", "son", " ", "las", " ", 
      "entrop\[IAcute]as", " ", "topol\[OAcute]gicas", " ", "de", " ", "cada",
       " ", "ventana"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{"PASO", " ", "4"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "REALIZAMOS", " ", "EL", " ", "CONTRASTE", " ", "DE", " ", 
      "HIP\[CapitalOAcute]TESIS"}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "Calculamos", " ", "el", " ", "estad\[IAcute]stico", " ", "de", " ", 
      RowBox[{"contraste", "."}]}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"prob", "[", 
      RowBox[{"k_", ",", "m_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"N", "[", 
      RowBox[{
       RowBox[{"StirlingS2", "[", 
        RowBox[{"k", ",", "t"}], "]"}], "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"m", "!"}], ")"}], "!"}], "/", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"m", "!"}], "-", "t"}], ")"}], "!"}]}], ")"}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "/", 
          RowBox[{"m", "!"}]}], ")"}], "^", "k"}]}], "]"}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
     "funci\[OAcute]n", " ", "puntual", " ", "de", " ", "probabilidad", " ", 
      "te\[OAcute]rica"}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"NMaxPermutacionesDiferentes", "=", 
     RowBox[{"Min", "[", 
      RowBox[{"k", ",", 
       RowBox[{"m", "!"}]}], "]"}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
     "n\[UAcute]mero", " ", "m\[AAcute]ximo", " ", "de", " ", "permutaciones",
       " ", "diferentes", " ", "en", " ", "cada", " ", "ventana"}], "*)"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"sumaEstContraste", "=", "0"}], ";"}], " ", "\[IndentingNewLine]",
    "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "Contamos", " ", "las", " ", "ventanas", " ", "que", " ", "tienen", " ", 
     "cada", " ", "uno", " ", "de", " ", "los", " ", "posibles", " ", 
     "valores", " ", "que", " ", "puede", " ", "tener", " ", "el", " ", 
     "n\[UAcute]mero", " ", "de", " ", "permutaciones", " ", 
     RowBox[{"diferentes", "."}]}], "*)"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"cont5", "=", "1"}], ",", 
      RowBox[{"cont5", "\[LessSlantEqual]", "NMaxPermutacionesDiferentes"}], 
      ",", 
      RowBox[{"cont5", "++"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"fi", "=", "0"}], ";", " ", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"ei", "=", 
        RowBox[{"Nventanas", "*", 
         RowBox[{"prob", "[", 
          RowBox[{"k", ",", "m", ",", "cont5"}], "]"}]}]}], ";", " ", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"cont6", "=", "1"}], ",", 
         RowBox[{"cont6", "\[LessSlantEqual]", "Nventanas"}], ",", 
         RowBox[{"cont6", "++"}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"cont5", "\[Equal]", 
             RowBox[{"vectorNpermutacionesDiferentes", "[", 
              RowBox[{"[", "cont6", "]"}], "]"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"fi", "=", 
              RowBox[{"fi", "+", "1"}]}], ";"}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"sumaEstContraste", "=", 
        RowBox[{"sumaEstContraste", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"fi", "-", "ei"}], ")"}], "^", "2"}], ")"}], "/", 
          "ei"}]}]}], ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
     "]"}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"EstContraste", "=", "sumaEstContraste"}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{"estad\[IAcute]stico", " ", "de", " ", "contraste"}], "*)"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "Determinamos", " ", "el", " ", "valor", " ", "l\[IAcute]mite", " ", 
      "que", " ", "fijar\[AAcute]", " ", "la", " ", "zona", " ", "de", " ", 
      "rechazo", " ", "de", " ", "la", " ", "hip\[OAcute]tesis", " ", 
      RowBox[{"nula", "."}]}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"gradosLibertad", "=", 
     RowBox[{"NMaxPermutacionesDiferentes", "-", "1"}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{"grados", " ", "de", " ", "libertad"}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"chiCuadrado", "=", 
     RowBox[{"InverseCDF", "[", 
      RowBox[{
       RowBox[{"ChiSquareDistribution", "[", "gradosLibertad", "]"}], ",", 
       RowBox[{"nivelConfianza", "/", "100"}]}], "]"}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
     "funci\[OAcute]n", " ", "de", " ", "distribuci\[OAcute]n", " ", "Chi", 
      " ", "cuadrado"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "Si", " ", "la", " ", "variable", " ", "test22", " ", "toma", " ", "el",
        " ", "valor", " ", "1"}], ",", " ", 
      RowBox[{
      "no", " ", "rechazamos", " ", "la", " ", "hip\[OAcute]tesis", " ", 
       RowBox[{"nula", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"Si", " ", "en", " ", "cambio"}], ",", " ", 
      RowBox[{
      "la", " ", "variable", " ", "test22", " ", "toma", " ", "el", " ", 
       "valor", " ", "0"}], ",", " ", 
      RowBox[{
      "s\[IAcute]", " ", "rechazamos", " ", "la", " ", "hip\[OAcute]tesis", 
       " ", 
       RowBox[{"nula", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"EstContraste", "<", "chiCuadrado"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"test22", "=", "1"}], ",", " ", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"test22", "=", "0"}], ";"}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   "\"\<Representaci\[OAcute]n gr\[AAcute]fica de los elementos de la serie \
temporal\>\"", "\[IndentingNewLine]", 
   RowBox[{"ListPlot", "[", "serie", "]"}], "\[IndentingNewLine]", 
   "\"\<Entrop\[IAcute]a topol\[OAcute]gica de cada ventana\>\"", 
   "\[IndentingNewLine]", "vectorH", "\[IndentingNewLine]", 
   "\"\<Gr\[AAcute]fica del n\[UAcute]mero de permutaciones diferentes de \
cada ventana (vector de entrop\[IAcute]as)\>\"", "\[IndentingNewLine]", 
   RowBox[{"ListLinePlot", "[", "vectorH", "]"}], "\[IndentingNewLine]", 
   "\"\<Estad\[IAcute]stico de contraste\>\"", "\[IndentingNewLine]", 
   "EstContraste", "\[IndentingNewLine]", 
   "\"\<Distribuci\[OAcute]n Chi cuadrado\>\"", " ", "\[IndentingNewLine]", 
   RowBox[{"N", "[", "chiCuadrado", "]"}], "\[IndentingNewLine]", 
   "\"\<Resultado del test\>\"", "\[IndentingNewLine]", "test22"}]}]], "Input",
 CellChangeTimes->{{3.5302143244007907`*^9, 3.5302143299232006`*^9}, {
   3.530214362246457*^9, 3.5302143866917*^9}, {3.5302153860606556`*^9, 
   3.5302153916922655`*^9}, {3.530215433453539*^9, 3.5302156106698503`*^9}, {
   3.5302156753163633`*^9, 3.5302156754723635`*^9}, {3.530215755703305*^9, 
   3.5302159006899595`*^9}, {3.5302168591104527`*^9, 
   3.5302168613724566`*^9}, {3.5302169022601285`*^9, 3.530216907174137*^9}, {
   3.5302169407453957`*^9, 3.5302170312879553`*^9}, {3.530217546593272*^9, 
   3.530217569884113*^9}, {3.5302176117701864`*^9, 3.530217636121829*^9}, {
   3.530217746008422*^9, 3.530217750111229*^9}, {3.5302178751454487`*^9, 
   3.5302179324287496`*^9}, {3.5302307506654844`*^9, 3.530230974636295*^9}, {
   3.530231010708358*^9, 3.530231064028408*^9}, {3.530231110325056*^9, 
   3.530231300599939*^9}, {3.5302313339768476`*^9, 3.5302313451664877`*^9}, 
   3.530231475317932*^9, {3.5302315875643525`*^9, 3.5302315930896683`*^9}, {
   3.53023163997635*^9, 3.5302316589344344`*^9}, {3.53023172423617*^9, 
   3.530231784340607*^9}, {3.530231820882697*^9, 3.5302318904596767`*^9}, {
   3.530231920655404*^9, 3.530231921619459*^9}, 3.530231977614662*^9, {
   3.530232158919032*^9, 3.530232328921756*^9}, {3.530232413906616*^9, 
   3.530232417592827*^9}, {3.5302324902029805`*^9, 3.530232506126891*^9}, 
   3.530232589553663*^9, {3.5302326322971077`*^9, 3.530232684982871*^9}, {
   3.5302327247629414`*^9, 3.530232730238551*^9}, {3.5302327851974473`*^9, 
   3.5302327876778517`*^9}, {3.530232822902714*^9, 3.530232823152314*^9}, {
   3.530232892588036*^9, 3.530232946564131*^9}, {3.5302330027554293`*^9, 
   3.530233032083481*^9}, {3.5302330744531555`*^9, 3.5302331885829563`*^9}, {
   3.530233243339052*^9, 3.530233244337454*^9}, {3.530233330434005*^9, 
   3.530233422115366*^9}, {3.5302348802499275`*^9, 3.530234929046813*^9}, {
   3.5302350116021576`*^9, 3.5302351268239603`*^9}, {3.5302352129517117`*^9, 
   3.5302352180217204`*^9}, {3.5302353677975836`*^9, 
   3.5302353779532013`*^9}, {3.5303841762521224`*^9, 3.53038419762416*^9}, {
   3.5303842505862527`*^9, 3.53038426587428*^9}, {3.5303843227987795`*^9, 
   3.530384344498418*^9}, {3.5303843832176857`*^9, 3.5303843841536875`*^9}, {
   3.530384418239747*^9, 3.5303845589831944`*^9}, {3.530384597905263*^9, 
   3.530384620182102*^9}, 3.5303846640025787`*^9, {3.5303847166370716`*^9, 
   3.5303847247490854`*^9}, {3.5303847790683813`*^9, 
   3.5303847838575897`*^9}, {3.53038486957974*^9, 3.5303849802619343`*^9}, {
   3.5303850714128942`*^9, 3.530385075640502*^9}, {3.530385358531399*^9, 
   3.5303853843026443`*^9}, {3.5303854319607277`*^9, 3.5303854729888*^9}, {
   3.530385553079341*^9, 3.530385589770605*^9}, {3.5303856462427044`*^9, 
   3.5303857363016624`*^9}, {3.5303859335484085`*^9, 3.530386048754611*^9}, {
   3.5303862495585747`*^9, 3.530386249698975*^9}, {3.5303862813046308`*^9, 
   3.530386284799037*^9}, 3.5303863478699474`*^9, {3.530386554554711*^9, 
   3.530386619154424*^9}, 3.5303867859967175`*^9, {3.530400092231921*^9, 
   3.5304001269575825`*^9}, {3.5304004493633485`*^9, 3.530400450798551*^9}, {
   3.5304008258388095`*^9, 3.530400845167244*^9}, {3.530401216557096*^9, 
   3.5304012173682976`*^9}, {3.5304015670897117`*^9, 3.530401569008515*^9}, {
   3.5304018735366497`*^9, 3.5304019012266984`*^9}, {3.5304020491929584`*^9, 
   3.5304020740438023`*^9}, {3.530402137333113*^9, 3.530402176520382*^9}, 
   3.5304022531477165`*^9, {3.5304023099942164`*^9, 3.5304023202122345`*^9}, {
   3.530402436806839*^9, 3.530402521530588*^9}, {3.5304027363741655`*^9, 
   3.530402741272574*^9}, {3.53040279014746*^9, 3.530402793735466*^9}, {
   3.5304028321115336`*^9, 3.530402832236334*^9}, {3.5304029529493456`*^9, 
   3.5304029761153865`*^9}, {3.530403114570739*^9, 3.530403185691821*^9}, {
   3.5304032305392733`*^9, 3.5304032500523405`*^9}, {3.5304032828115273`*^9, 
   3.530403296819293*^9}, {3.5304033732982645`*^9, 3.5304033892841372`*^9}, 
   3.5304034533850317`*^9, 3.53040350711497*^9, {3.5304035712944665`*^9, 
   3.5304036080986795`*^9}, {3.530404343449093*^9, 3.5304044311622705`*^9}, {
   3.5304045209085054`*^9, 3.5304045503785477`*^9}, {3.5304045895716577`*^9, 
   3.530404610291687*^9}, {3.5304046892809234`*^9, 3.5304047175509624`*^9}, {
   3.530404781184107*^9, 3.5304048903183703`*^9}, {3.530404944211501*^9, 
   3.530404967321533*^9}, {3.5304050137986774`*^9, 3.530405013998678*^9}, {
   3.5304051393999634`*^9, 3.530405201620051*^9}, {3.530405256653195*^9, 
   3.5304052600931997`*^9}, {3.530405346743321*^9, 3.5304053642933455`*^9}, {
   3.5304054261684875`*^9, 3.5304054328984966`*^9}, {3.5304056106358576`*^9, 
   3.530405673355945*^9}, {3.530405734636031*^9, 3.5304057902661085`*^9}, {
   3.5304058565262012`*^9, 3.530405856806202*^9}, {3.5304060033333325`*^9, 
   3.5304060038127437`*^9}, {3.5304060732449837`*^9, 3.530406073853213*^9}, {
   3.5304062166340046`*^9, 3.530406223375925*^9}, {3.530406257045134*^9, 
   3.530406258074986*^9}, {3.5304918513090925`*^9, 3.530491872135129*^9}, {
   3.530491955454875*^9, 3.5304920061705647`*^9}, {3.5304920489614396`*^9, 
   3.530492135401191*^9}, {3.5304921863196807`*^9, 3.530492196085298*^9}, {
   3.530494470883588*^9, 3.5304945093746285`*^9}, {3.532294960592233*^9, 
   3.5322949730878553`*^9}, {3.5322951111480975`*^9, 3.532295138619746*^9}, {
   3.5322952360263166`*^9, 3.5322952978492255`*^9}, {3.5322953490017157`*^9, 
   3.5322953791097684`*^9}, {3.532295461836714*^9, 3.532295496858775*^9}, {
   3.5322955623944902`*^9, 3.532295603672163*^9}, 3.5323044921317177`*^9, 
   3.532304589600689*^9, {3.532304642781183*^9, 3.5323046514235983`*^9}, {
   3.5323047212337203`*^9, 3.5323047424965577`*^9}, {3.532304901273637*^9, 
   3.5323049036604404`*^9}, {3.532304942520109*^9, 3.53230494300371*^9}, {
   3.5323050416270833`*^9, 3.532305044357088*^9}, {3.532306445645149*^9, 
   3.532306534799306*^9}, {3.5323065720365715`*^9, 3.5323066269174676`*^9}, {
   3.53230665700992*^9, 3.5323066611127276`*^9}, 3.5323067003623967`*^9, {
   3.5323069547208433`*^9, 3.532306977777684*^9}, {3.532307368901571*^9, 
   3.5323073881520047`*^9}, {3.532307983683051*^9, 3.5323080075198927`*^9}, {
   3.532308039484349*^9, 3.532308053259173*^9}, {3.5323086014129353`*^9, 
   3.532308625109377*^9}, {3.532308958840763*^9, 3.532309011943257*^9}, {
   3.5323091859927626`*^9, 3.532309188722767*^9}, {3.5323092190336204`*^9, 
   3.5323092287836375`*^9}, {3.5323092997793627`*^9, 3.532309312462185*^9}, {
   3.5323095262761602`*^9, 3.5323095612202215`*^9}, {3.532309670264413*^9, 
   3.532309672183216*^9}, {3.532309715270492*^9, 3.532309716627694*^9}, {
   3.5323097647693787`*^9, 3.53230978799782*^9}, {3.5323098314438963`*^9, 
   3.5323098737199707`*^9}, 3.5323099130320396`*^9, {3.532309961111324*^9, 
   3.5323099992845907`*^9}, {3.53231026069425*^9, 3.5323102616926517`*^9}, {
   3.53231031016366*^9, 3.532310389021799*^9}, {3.5323444910452156`*^9, 
   3.532344524398074*^9}, 3.5323447960806594`*^9, 3.5323483590261145`*^9, {
   3.5323489668646793`*^9, 3.5323491128180285`*^9}, {3.5323491455450315`*^9, 
   3.5323491899956207`*^9}, {3.5323492266357517`*^9, 3.532349232034577*^9}, {
   3.5323492852354317`*^9, 3.5323492885774174`*^9}, {3.5323498438812027`*^9, 
   3.5323498810902877`*^9}, {3.532352164623191*^9, 3.5323521819929256`*^9}, {
   3.5323523030152564`*^9, 3.5323523057496023`*^9}, {3.5323523358064246`*^9, 
   3.532352360917378*^9}, {3.532355442776186*^9, 3.532355455080428*^9}, {
   3.532355609088916*^9, 3.5323556184802113`*^9}, {3.5323557031518545`*^9, 
   3.5323557560884333`*^9}, {3.532355813163628*^9, 3.5323559604779615`*^9}, {
   3.5323559924562426`*^9, 3.532355995343192*^9}, {3.5323560880394764`*^9, 
   3.5323561154673166`*^9}, {3.5323647315662956`*^9, 3.532364743456976*^9}, {
   3.532364786495437*^9, 3.5323647869814653`*^9}, {3.5323649305011864`*^9, 
   3.532364933418543*^9}, {3.5323650169947376`*^9, 3.532365018668023*^9}, 
   3.532648089827497*^9, {3.5326487493476596`*^9, 3.5326487788121576`*^9}, {
   3.5326499539778214`*^9, 3.5326499630414376`*^9}, {3.532650115968506*^9, 
   3.532650179601018*^9}, {3.532650230956308*^9, 3.532650242047928*^9}, {
   3.5326503015620317`*^9, 3.53265030582084*^9}, {3.5326523514518824`*^9, 
   3.5326523521850843`*^9}, {3.532652913310607*^9, 3.5326529138576384`*^9}, {
   3.5355878278638916`*^9, 3.535587901558421*^9}, {3.535587935862881*^9, 
   3.535587942461693*^9}, {3.5355879770469537`*^9, 3.53558825976625*^9}, {
   3.535588297440316*^9, 3.5355884025221004`*^9}, 3.5355884791962357`*^9, {
   3.5363910546696625`*^9, 3.5363910552468634`*^9}, {3.536425796361888*^9, 
   3.53642579764109*^9}, {3.536438374934363*^9, 3.5364383820327473`*^9}, {
   3.5364384200815296`*^9, 3.536438548953615*^9}, {3.5364385892355356`*^9, 
   3.536438610864674*^9}, {3.536438641033184*^9, 3.5364387689068904`*^9}, 
   3.5364399031199465`*^9}]
},
WindowSize->{1264, 825},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (November 7, 2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 37262, 767, 3995, "Input"]
}
]
*)

(* End of internal cache information *)
